package sposaro.android.client;

import java.io.IOException;
import java.net.ServerSocket;

import org.apache.http.HttpServerConnection;

import android.content.Context;
import android.util.Log;

public class PhoneServer extends Thread {
	private int port;
	private int id;
	private Context context;
	public boolean listening = true;
	
	public PhoneServer(int port,Context context){
		this.port = port;
		this.context = context;
		id = 0;
	}
	
	public void run(){
			
		  ServerSocket serverSocket = null;
		  Log.i("sposaro.android.client.PhoneServer","Starting Phone Server on port :" + port);
		  
	        try {
	            serverSocket = new ServerSocket(port);
	            
	           
	            while (listening)
	    		    new PhoneServerThread(serverSocket.accept(), id++,context).start();
	    		    
	            serverSocket.close();
	            
	        } catch (IOException e) {
	            System.err.println("Could not listen on port: " + port);
	            System.exit(-1);
	        }
	       
	     
	        System.out.println("Closing Phone Server Client " + id);
	        
	}
	
	public void close(){
		listening = false;
	}
}
