package sposaro.android.client;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;
import java.security.MessageDigest;

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

public class PhoneServerThread extends Thread {
	private Socket socket;
	private int id;
	private static String TAG = "sposaro.android.client.PhoneServerThread";
	private static String src_dir = "/sdcard/shared/";
	private OutputStream os;
	private Context context;
	
	public PhoneServerThread(Socket accept, int i, Context context) {
		id = i;
		socket = accept;
		this.context = context;
	}
	
	public void run(){
		Log.i(TAG, "Starting PhoneServerThread id " + id);
		
		String fileName = "DEFAULT";
		
		try {
			os = socket.getOutputStream( );
			BufferedReader in = new BufferedReader(new InputStreamReader(socket.getInputStream( )));
			
					
			// Waiting for the Client to send the requested File
			fileName = src_dir + in.readLine();
			Log.i(TAG, "Requested File " + fileName);
			
			
			File myFile = new File (fileName);
			
			// Checking if file Exsits
			if(!myFile.exists()){
				Log.i(TAG,"Error. File " + fileName + " does not exsist");
				in.close();
				os.close();
				socket.close();
				return;
			}
						
			// Sending out big the file is
			Log.i(TAG,"File " + fileName + " is " + ((int)myFile.length()) + " bytes");
		    
			/*
			FileInputStream fis = new FileInputStream(myFile);
			byte [] fullBuff = new byte[(int)myFile.length()];
			
			fis.read(fullBuff, 0, (int)myFile.length());			
			*/
			
			/*
			String hash = SimpleSHA1.SHA1(new String(fullBuff));
			
			String hash = SimpleSHA1.SHA1(fullBuff);
			*/
			
			FileInputStream fileInputStream = new FileInputStream(myFile);
			/*
			byte[] bytearr = new byte[hash.length()];
			System.arraycopy(hash.toCharArray(), 0, bytearr, 0, hash.length());
			Log.i(TAG, "hash is " + hash + " for file " + fileName);
			//os.write(bytearr);
			*/
			FileInputStream fis = new FileInputStream(myFile);
			
			byte[] dataBytes = new byte[1024];
			 
		    int nread = 0; 
		    MessageDigest md = MessageDigest.getInstance("SHA1");
		    while ((nread = fis.read(dataBytes)) != -1) {
		      md.update(dataBytes, 0, nread);
		      
		    };
		    byte[] mdbytes = md.digest();
			
		    
		    Log.i(TAG,"hash is " + SimpleSHA1.encode(mdbytes));
		    
		    os.write(intToByteArray(mdbytes.length));
		    os.write(mdbytes);
		    
			SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context);
			boolean badData = prefs.getBoolean("send_bad_data", false);
		    
			byte [] buffer = new byte[1024];
			int len;
			while ((len = fileInputStream.read(buffer)) != -1){  
				if(badData)
					os.write(buffer, 0, (len >0)? len-1 : len);  
				else
					os.write(buffer, 0, len);
			}
        
		   
			fileInputStream.close();
  		   	os.flush(); 
			in.close();   
		    os.close();
		    socket.close();
				
		} catch (Exception e) {
			Log.i(TAG, "ERROR SOCKET");
			e.printStackTrace();
		}
		
		
		Log.i(TAG, "File " + fileName + " to client " + id + " complete");
	}
	
	public static final byte[] intToByteArray(int value) {
		return new byte[]{ 
		(byte)(value >>> 24), (byte)(value >> 16 & 0xff), (byte)(value >> 8 & 0xff), (byte)(value & 0xff) };
		}
}
